<?php

namespace FiloBlu\ExtMailChimp\Plugin\Helper;

use Magento\Newsletter\Model\Subscriber;
use Magento\Store\Model\StoreManagerInterface;

/**
 * Class Data
 * @package FiloBlu\ExtMailChimp\Plugin\Helper
 */
class Data
{
    /**
     * @var \FiloBlu\ExtMailChimp\Helper\Data
     */
    private $helperData;
    /**
     * @var StoreManagerInterface
     */
    private $storeManager;

    /**
     * Data constructor.
     * @param \FiloBlu\ExtMailChimp\Helper\Data $helperData
     * @param StoreManagerInterface $storeManager
     */
    public function __construct(\FiloBlu\ExtMailChimp\Helper\Data $helperData, StoreManagerInterface $storeManager)
    {
        $this->helperData = $helperData;
        $this->storeManager = $storeManager;
    }

    /**
     * @param $subject
     * @param $return
     * @param Subscriber $subscriber
     * @param null $email
     * @return array|null
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     * @see \Ebizmarts\MailChimp\Helper\Data::getMergeVarsBySubscriber
     *
     */
    public function afterGetMergeVarsBySubscriber($subject, $return, Subscriber $subscriber, $email = null)
    {
        if($subscriber->getId()) {
            // FORCE LOAD
            $subscriber->load($subscriber->getId());
            $data = $this->helperData->getMergeVars($subscriber, $subscriber->getStoreId()) ?? [];
        }else{
            $subscriber->setEmail($email);
            $data = $this->helperData->getMergeVars($subscriber, $this->storeManager->getStore()->getId()) ?? [];
        }

        return array_filter(array_merge($return??[], $data));
    }
}
